#include <iostream>
#include "PerformanceMonitor.h"

using namespace std;

void main(void)
{
	try
	{
		for (int j=0; j<5; ++j)
		{
			Profile("Frame");

			{
				Profile("Input");
				for(int k=0; k<8000; ++k);
			}

			{
				Profile("AI");
				for(int k=0; k<20000; ++k);
			}

			{
				Profile("Physics");
				for(int k=0; k<30000; ++k);
			}

			{
				Profile("Collision");
				for(int k=0; k<40000; ++k);
			}

			{
				Profile("Renderer");
				{
					Profile("Terrain");
					for(int k=0; k<40000; ++k);
				}
				{
					Profile("Models");
					for(int k=0; k<40000; ++k);
				}
			}
		}
	}
	catch(...)
	{

	}

	//Dummy reporting process.
	std::string Tabs;
	for (tree<CPerformanceStatistics>::iterator itr = CPerformanceMonitor::Statistics.begin(); itr != CPerformanceMonitor::Statistics.end(); ++itr)
	{
		Tabs.resize(CPerformanceMonitor::Statistics.depth(itr) * 4);

		tree<CPerformanceStatistics>::iterator Parent = CPerformanceMonitor::Statistics.parent(itr);
		if (Parent == 0)
			std::cout << Tabs << itr->Name << " : 100" << std::endl;
		else
		{
			itr->Percent = ((float)itr->TotalTime / (float)Parent->TotalTime) * Parent->Percent;
			std::cout << Tabs << itr->Name << " : " << itr->Percent * 100 << std::endl;
		}
		

		//std::cout << Tabs << itr->Name << " Minimum : " << itr->Min << std::endl;
		//std::cout << Tabs << itr->Name << " Maximum : " << itr->Max << std::endl;
		//std::cout << Tabs << itr->Name << " Average : " << itr->TotalTime/itr->Samples << std::endl;
		//std::cout << Tabs << itr->Name << " Total   : " << itr->TotalTime << std::endl;
		//std::cout << Tabs << itr->Name << " Samples : " << itr->Samples << std::endl;
	}


}